pipeline {
    agent {
        node {
            label 'build-agent-proxmox'
        }
    }
    stages {
        stage('Maven build') {
            steps {
                sh 'mvn clean install -DskipTests'
            }
        }

        stage('Docker build') {
            steps {
                sh '''
                docker build -t registry.gitlab.com/m2m-auth/mtls/hello-client:prod-$BUILD_NUMBER-$GIT_COMMIT .
                docker push registry.gitlab.com/m2m-auth/mtls/hello-client:prod-$BUILD_NUMBER-$GIT_COMMIT
                '''
            }
        }

        stage('Deploy to kubernetes') {
            steps {
                sh '''
                    helm upgrade hello-client https://helm-templates.nicholasmeyers.be/meyers-app-0.1.7.tgz -n m2m-mtls \
                    --set image.repository=registry.gitlab.com/m2m-auth/mtls/hello-client:prod-$BUILD_NUMBER-$GIT_COMMIT \
                    --set service.port=8080 \
                    --set health.enabled=true \
                    --set fullnameOverride=hello-client \
                    --set private.registry=false \
                    --set env.enabled.secret=false \
                    --set env.enabled.config=false \
                    --create-namespace --install
                '''
            }
        }
    }
}